#pragma once

namespace Core
{
	// vertexArray - one-dimensional array of values describing the positions of consecutive vertices (x1, y1, z1, w1, x2, y2, z2, w2, ...)
	// numVertices - number of vertices to draw narysowania
	// elementSize - number of values describing each vertex (e.g. 3 if a vertex is composed of three coordinates (x, y, z))
	void DrawVertexArray(const float * vertexArray, int numVertices, int elementSize);

	// indexArray - one-dimensional array of indices of the vertices composing the triangles (t1_i1, t1_i2, t1_i3, t2_i1, t2_i2, t2_i3, ...)
	// numIndexes - number of indices in the array indexArray
	void DrawVertexArrayIndexed(const float * vertexArray, const int * indexArray, int numIndexes, int elementSize);
}