#include "glew.h"
#include "freeglut.h"

#include "Shader_Loader.h"
#include "Render_Utils.h"

void renderScene()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// EXERCISE: Look at the code and comments
	// EXERCISE: Change the background color of the scene assuming floating point RGBA standard
	glClearColor(0.0f, 0.3f, 0.3f, 1.0f);

	// Should be called after finishing each frame
	glutSwapBuffers();
}

void init()
{
	
}

void shutdown()
{
	
}

void idle()
{
	// This function informs freeglut that the screen should be refreshed using the function given for as argument to glutDisplayFunc
	glutPostRedisplay();
}

int main(int argc, char ** argv)
{
	// Creating a window using freeglut
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(200, 200);
	glutInitWindowSize(600, 600);
	glutCreateWindow("OpenGL Pierwszy Program");

	// Initializations of OpenGL extensions
	glewInit();

	// Intialisation of the program (loading of shaders, textures, etc.)
	init();

	// Which function we are using to refresh the screen is given as argument to glutDisplayFunc
	glutDisplayFunc(renderScene);
	// Informing freeglut which function will be used for the main loop of the program
	glutIdleFunc(idle);

	// starting the main loop
	glutMainLoop();

	// Garbage collection
	shutdown();

	return 0;
}
